/*
 * PointCloud.hpp
 *
 *  Created on: Jul 29, 2010
 *      Author: heber
 */

#ifndef POINTCLOUD_HPP_
#define POINTCLOUD_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <cstdio>

class TesselPoint;
class Vector;

/** Super-class for all point clouds structures, also molecules. They have to inherit this structure and implement the virtual function to access the Vectors.
 * This basically encapsulates a list structure.
 */
class PointCloud {
public:
  PointCloud();
  virtual ~PointCloud();

  virtual const char * const GetName() const=0;
  virtual Vector *GetCenter() const=0;
  virtual TesselPoint *GetPoint() const=0;
  virtual int GetMaxId() const=0;
  virtual void GoToNext() const=0;
  virtual void GoToFirst() const=0;
  virtual bool IsEmpty() const=0;
  virtual bool IsEnd() const=0;
};


#endif /* POINTCLOUD_HPP_ */
